#include once "windows.bi"
#include once "win/winsock2.bi"

type CDDB_Connect_Info
	username as string
	hostname as string
	clientname as string
	version as string
end type

type CDDB_Query_Request
	discid as string
	querystring as string
end type

type CDDB_Disc_Info
	dcateg as string
	discid as string
	dtitle as string
end type

type CDDB_Track_Info
	ttitle as string
end type

type CDDB_Query_Result
	ndiscs as integer
	discs(0 to 15) as CDDB_Disc_Info
end type

type CDDB_Read_Request
	dcateg as string
	discid as string
end type

type CDDB_Read_Result
	ntracks as integer
	tracks(0 to 99) as CDDB_Track_Info
	record as string
end type

declare function CDDB_send _
	( _
		byval s as SOCKET, _
		byref cmd as string _
	) as integer
declare function CDDB_readline _
	( _
		byval s as SOCKET, _
		byref x as string _
	) as integer
declare function CDDB_readresponse _
	( _
		byval s as SOCKET _
	) as integer
declare function CDDB_connect _
	( _
		byval s as SOCKET, _
		byref cddb as CDDB_Connect_Info _
	) as integer
declare function CDDB_query _
	( _
		byval s as SOCKET, _
		byref query as CDDB_Query_Request, _
		byref result as CDDB_Query_Result _
	) as integer
declare function CDDB_read( _
		byval s as SOCKET, _
		byref request as CDDB_Read_Request, _
		byref result as CDDB_Read_Result _
	) as integer
declare function CDDB_quit _
	( _
		byval s as SOCKET _
	) as integer
