#include once "windows.bi"
#include once "win/winsock2.bi"
#include once "logtool.bi"
#include once "sockerr.bi"

type WSAERRORITEM
	errnum as integer
	text as zstring * 31
end type

static shared wsaerrorlist(0 to 63) as WSAERRORITEM = { _
	( WSAEINTR, "WSAEINTR" ), _
	( WSAEBADF, "WSAEBADF" ), _
	( WSAEACCES, "WSAEACCES" ), _
	( WSAEFAULT, "WSAEFAULT" ), _
	( WSAEINVAL, "WSAEINVAL" ), _
	( WSAEMFILE, "WSAEMFILE" ), _
	( WSAEWOULDBLOCK, "WSAEWOULDBLOCK" ), _
	( WSAEINPROGRESS, "WSAEINPROGRESS" ), _
	( WSAEALREADY, "WSAEALREADY" ), _
	( WSAENOTSOCK, "WSAENOTSOCK" ), _
	( WSAEDESTADDRREQ, "WSAEDESTADDRREQ" ), _
	( WSAEMSGSIZE, "WSAEMSGSIZE" ), _
	( WSAEPROTOTYPE, "WSAEPROTOTYPE" ), _
	( WSAENOPROTOOPT, "WSAENOPROTOOPT" ), _
	( WSAEPROTONOSUPPORT, "WSAEPROTONOSUPPORT" ), _
	( WSAESOCKTNOSUPPORT, "WSAESOCKTNOSUPPORT" ), _
	( WSAEOPNOTSUPP, "WSAEOPNOTSUPP" ), _
	( WSAEPFNOSUPPORT, "WSAEPFNOSUPPORT" ), _
	( WSAEAFNOSUPPORT, "WSAEAFNOSUPPORT" ), _
	( WSAEADDRINUSE, "WSAEADDRINUSE" ), _
	( WSAEADDRNOTAVAIL, "WSAEADDRNOTAVAIL" ), _
	( WSAENETDOWN, "WSAENETDOWN" ), _
	( WSAENETUNREACH, "WSAENETUNREACH" ), _
	( WSAENETRESET, "WSAENETRESET" ), _
	( WSAECONNABORTED, "WSAECONNABORTED" ), _
	( WSAECONNRESET, "WSAECONNRESET" ), _
	( WSAENOBUFS, "WSAENOBUFS" ), _
	( WSAEISCONN, "WSAEISCONN" ), _
	( WSAENOTCONN, "WSAENOTCONN" ), _
	( WSAESHUTDOWN, "WSAESHUTDOWN" ), _
	( WSAETOOMANYREFS, "WSAETOOMANYREFS" ), _
	( WSAETIMEDOUT, "WSAETIMEDOUT" ), _
	( WSAECONNREFUSED, "WSAECONNREFUSED" ), _
	( WSAELOOP, "WSAELOOP" ), _
	( WSAENAMETOOLONG, "WSAENAMETOOLONG" ), _
	( WSAEHOSTDOWN, "WSAEHOSTDOWN" ), _
	( WSAEHOSTUNREACH, "WSAEHOSTUNREACH" ), _
	( WSAENOTEMPTY, "WSAENOTEMPTY" ), _       
	( WSAEPROCLIM, "WSAEPROCLIM" ), _
	( WSAEUSERS, "WSAEUSERS" ), _
	( WSAEDQUOT, "WSAEDQUOT" ), _
	( WSAESTALE, "WSAESTALE" ), _
	( WSAEREMOTE, "WSAEREMOTE" ), _
	( WSASYSNOTREADY, "WSASYSNOTREADY" ), _
	( WSAVERNOTSUPPORTED, "WSAVERNOTSUPPORTED" ), _
	( WSANOTINITIALISED, "WSANOTINITIALISED" ), _
	( WSAEDISCON, "WSAEDISCON" ), _
/'	( WSAENOMORE, "WSAENOMORE" ), _
	( WSAECANCELLED, "WSAECANCELLED" ), _
	( WSAEINVALIDPROCTABLE, "WSAEINVALIDPROCTABLE" ), _
	( WSAEINVALIDPROVIDER, "WSAEINVALIDPROVIDER" ), _
	( WSAEPROVIDERFAILEDINIT, "WSAEPROVIDERFAILEDINIT" ), _
	( WSASYSCALLFAILURE, "WSASYSCALLFAILURE" ), _
	( WSASERVICE_NOT_FOUND, "WSASERVICE_NOT_FOUND" ), _
	( WSATYPE_NOT_FOUND, "WSATYPE_NOT_FOUND" ), _
	( WSA_E_NO_MORE, "WSA_E_NO_MORE" ), _
	( WSA_E_CANCELLED, "WSA_E_CANCELLED" ), _
	( WSAEREFUSED, "WSAEREFUSED" ), _
'/	( WSAHOST_NOT_FOUND, "WSAHOST_NOT_FOUND" ), _
	( WSATRY_AGAIN, "WSATRY_AGAIN" ), _
	( WSANO_RECOVERY, "WSANO_RECOVERY" ), _
	( WSANO_DATA, "WSANO_DATA" ), _
	( 0, "" ) _
}

function GetSocketErrorText(byval errnum as integer) as string
	dim as integer i = 0
	for i = lbound( wsaerrorlist ) to ubound( wsaerrorlist )
		if( wsaerrorlist(i).errnum = errnum ) then
			function = "Error " & str(errnum) & ": " & wsaerrorlist(i).text
			exit function
		endif
	next i
	function = "Error " & str(errnum) & ": Unknown"
end function

sub ShowSocketError( byref text as string )
	logmsg( text & ": " & GetSocketErrorText(WSAGetLastError()) )
end sub
