#include once "windows.bi"
#include once "win/winsock2.bi"
#include once "logtool.bi"
#include once "sockerr.bi"
#include once "socktool.bi"

#define MAX_HOST_NAME 32

''
function SwapUint32 _
	( _
		byval x as uinteger _
	) as uinteger

	function = _
		(cuint(cast(ubyte ptr, @x)[0]) shl 24) _
		or (cuint(cast(ubyte ptr, @x)[1]) shl 16) _
		or (cuint(cast(ubyte ptr, @x)[2]) shl 8) _
		or (cuint(cast(ubyte ptr, @x)[3]) shl 0)

end function

''	    
function MakeInAddr( byval ipaddr as zstring ptr, byval port as ushort, byval addr as SOCKADDR_IN ptr) as integer

	dim as HOSTENT ptr heptr

	addr->sin_family = AF_INET
	addr->sin_port = htons(port)

	if (ipaddr) then
		addr->sin_addr.s_addr = inet_addr(ipaddr)
		if (addr->sin_addr.s_addr = INADDR_NONE) then  
			heptr = gethostbyname(ipaddr)
			if (heptr = NULL) then
				return(FALSE)
			end if
			addr->sin_addr.s_addr = *(cast(unsigned long ptr, heptr->h_addr))
		end if
	else
		addr->sin_addr.s_addr = INADDR_ANY
	end if

	return(TRUE)

end function

''
function GetAddrInText(byval iaddr as SOCKADDR_IN ptr) as string
	if( iaddr->sin_port = 0 ) then
		function = *inet_ntoa(iaddr->sin_addr)
	else
		function = *inet_ntoa(iaddr->sin_addr) & ":" & str(ntohs(iaddr->sin_port))
	end if
end function

''
function GetLocalHostName() as string
	static init as integer = 0
	static localhostname as zstring * MAX_HOST_NAME

	if( init = 0 ) then
		init = 1
		ZeroMemory(@localhostname, MAX_HOST_NAME)
		if (gethostname(localhostname, MAX_HOST_NAME) = SOCKET_ERROR) then
			''
		end if
		
	end if
	function = localhostname

end function

''
function ConnectToHost _
	( _
		byval socktype as SOCKET_TYPE, _
		byval localip as SOCKADDR_IN ptr, _
		byval remoteip as SOCKADDR_IN ptr, _
		byval retsock as SOCKET ptr _
	) as integer
	
	dim as SOCKET s
	dim as integer typ
	dim as integer parg = 1  
	
	select case socktype
	case TCP
		typ = SOCK_STREAM
	case UDP
		typ = SOCK_DGRAM
	case else
		typ = SOCK_STREAM
	end select

	''
	s = socket_(AF_INET, SOCK_STREAM, 0)
	if (s = INVALID_SOCKET) then
		ShowSocketError("socket()")
		return(FALSE)
	end if

	if (bind(s, cast(SOCKADDR ptr, localip), sizeof(SOCKADDR_IN)) = SOCKET_ERROR) then
		ShowSocketError("bind()")
		closesocket(s)
		return(FALSE)
	end if

	if (connect(s, cast(SOCKADDR ptr, remoteip), sizeof(SOCKADDR_IN)) = SOCKET_ERROR) then
		ShowSocketError("connect()")
		closesocket(s)
		return(FALSE)
	end if

	if (ioctlsocket( s, FIONBIO, @parg) = SOCKET_ERROR) then
		ShowSocketError("ioctlsocket(non-blocking)")
		closesocket(s)
		return(FALSE)
	end if

	*retsock = s

	return(TRUE)

end function

''
function ConnectToHostTCP _
	( _
		byval localip as SOCKADDR_IN ptr, _
		byval remoteip as SOCKADDR_IN ptr, _
		byval retsock as SOCKET ptr _
	) as integer

	function = ConnectToHost( TCP, localip, remoteip, retsock )

end function

''
function ConnectToHostUDP _
	( _
		byval localip as SOCKADDR_IN ptr, _
		byval remoteip as SOCKADDR_IN ptr, _
		byval retsock as SOCKET ptr _
	) as integer

	function = ConnectToHost( UDP, localip, remoteip, retsock )

end function
